config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :products
  resource :user_avatar, only: [:new, :create]

  root 'products#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/product.rb
class Product < ApplicationRecord
  include PgSearch::Model

  has_one_attached :picture

  pg_search_scope :search_for, against: %i(title description)

  validates :title, :price, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_one_attached :avatar
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :version

  def version
    @version = `git rev-parse HEAD`
  end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!, only: [:new, :create, :edit, :update]

  # GET /products
  # GET /products.json
  def index
    @products = Product.all
    @products = @products.search_for(params[:search]) if params[:search].present?
    @products = @products.page(params[:page])
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        format.html { redirect_to @product, notice: 'Product was successfully created.' }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to @product, notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
    @product.destroy
    respond_to do |format|
      format.html { redirect_to products_url, notice: 'Product was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_product
    @product = Product.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def product_params
    params.require(:product).permit(:title, :price, :description, :picture)
  end
end

app/controllers/user_avatars_controller.rb
class UserAvatarsController < ApplicationController
  before_action :authenticate_user!

  def new
  end

  def create
    current_user.update(user_params)

    redirect_to new_user_avatar_path,
      notice: 'Avatar was successfully set.'
  end

  private

  def user_params
    params.require(:user).permit(:avatar)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Demo</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div class="container">
      <ul class="nav-list">
        <li>
          <%= link_to('Home', root_path) %>
        </li>
        <li>
          <%= link_to 'New Product', new_product_path, class: 'link-btn' %>
        </li>
        <% if user_signed_in? %>
          <li>
            <%= link_to('Change avatar', new_user_avatar_path) %>
          </li>
          <li>
            <%= link_to('Edit registration', edit_user_registration_path) %>
          </li>
          <li>
            <%= link_to('Logout', destroy_user_session_path, method: :delete) %>
          </li>
        <% else %>
          <li>
            <%= link_to('Register', new_user_registration_path) %>
          </li>
          <li>
            <%= link_to('Login', new_user_session_path) %>
          </li>
        <% end %>
      </ul>


      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>

      <%= yield %>
      <% if @version.present? %>
        <div class="app-version">
          <span class="float-right">
            Rails environment: <%= Rails.env.to_s %>
            <br/>
            Session store: <%= Rails.application.config.session_store.name %>
            <br/>
            Cache: <%= Rails.cache.class.name %>
            <br/>
            Active Storage: <%= Rails.application.config.active_storage.service %>
          </span>
          <span>
            Ruby version: <%= RUBY_VERSION %>
            <br/>
            Rails version: <%= Rails.version %>
            <br/>
            Application version <%= @version %>
          </span>
        </div>
      <% end %>
    </div>
  </body>
</html>

app/views/products/_form.html.erb
<%= form_with(model: product, local: true) do |form| %>
  <% if product.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(product.errors.count, "error") %> prohibited this product from being saved:</h2>

      <ul>
      <% product.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title, required: true %>
  </div>

  <div class="field">
    <%= form.label :price %>
    <%= form.number_field :price, required: true %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description, rows: 10, cols: 50 %>
  </div>

  <div class="field">
    <%= form.label :picture %>
    <%= form.file_field :picture, required: true %>
    <small>Max 100KB</small>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/products/edit.html.erb
<h1>Editing Product</h1>

<%= render 'form', product: @product %>

app/views/products/index.html.erb
<h1>Products</h1>

<%= form_tag(products_path, method: :get) do %>
  <%= text_field_tag :search, params[:search] %>
  <%= submit_tag 'Search' %>
<% end %>

<br/>

<table class="table">
  <thead>
    <tr>
      <th>Picture</th>
      <th>Title</th>
      <th>Price</th>
      <th>Description</th>
      <th>Actions</th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
      <% cache product do %>
        <tr>
          <td><%= image_tag(product.picture, width: 50, height: 50) if product.picture.present? %></td>
          <td><%= link_to product.title, product %></td>
          <td><%= number_to_currency product.price %></td>
          <td><%= truncate product.description, length: 120 %></td>
          <td>
            <%= link_to 'Show', product %>
            |
            <%= link_to 'Delete', product, method: :delete, data: { confirm: 'Are you sure?' } %>
          </td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

<%= paginate @products %>

<br/>

<%= link_to 'New Product', new_product_path, class: 'link-btn' %>

app/views/products/new.html.erb
<h1>New Product</h1>

<%= render 'form', product: @product %>

app/views/products/show.html.erb
<h2><%= @product.title %></h2>

<h3>
  <strong>Price:</strong>
  <%= number_to_currency @product.price %>
</h3>

<div>
  <%= simple_format @product.description %>
</div>


<%- if @product.picture %>
  <div>
    <%= image_tag @product.picture %>
  </div>
<% end %>

<div class="show-info">
  <p>
  Created at <%= @product.created_at %><br/>
  Updated at <%= @product.updated_at %>
  </p>

  <%= link_to 'Edit', edit_product_path(@product) %>
  <%= link_to 'Destroy', @product, method: :delete, data: { confirm: 'Are you sure?' }, class: 'float-right' %>
</div>

app/views/user_avatars/new.html.erb
<h2>Change avatar</h2>

<% if current_user.avatar.attached? %>
  <div>
    <div>Current avatar:</div>
    <%= image_tag(current_user.avatar, width: 100, height: 100) %>
  </div>
  <br/>
<% end %>

<%= form_for(current_user, url: user_avatar_path, html: { method: :post, class: 'form' }) do |f| %>
  <div class="field">
    <%= f.label :avatar %>
    <%= f.file_field :avatar, required: true %>
  </div>

  <div class="actions">
    <%= f.submit "Save" %>
  </div>
<% end %>